<template>
  <v-card>
    <v-card-title class="title">
      Tutors
      <v-spacer />
      <v-btn
        icon
        @click="refresh"
      >
        <v-icon>refresh</v-icon>
      </v-btn>
    </v-card-title>
    <v-data-table
      :headers="headers"
      :items="tutors"
      item-key="pk"
    >
      <template #item.reservedSubmissions="{ item }">
        {{ item.reservedSubmissions }}
        <v-tooltip
          v-if="item.reservedSubmissions"
          top
        >
          <template #activator="{ on }">
            <v-icon
              small
              v-on="on"
              @click="deleteAssignmentsOfTutor(item)"
            >
              clear
            </v-icon>
          </template>
          <span>Free locked submissions</span>
        </v-tooltip>
      </template>
      <template #item.exerciseGroups="{ item }">
        <v-select
          v-model="item.exerciseGroups"
          item-text="name"
          item-value="pk"
          :items="groups"
          label="Set Groups"
          single-line
          return-object
          multiple
          chips
          dense
          hide-details
          filled
          @change="setExerciseGroups($event, item)"
        />
      </template>
      <template #item.isActive="{ item }">
        <v-btn
          v-if="canRevokeAccess(item.username)"
          icon
          @click="changeActiveStatus(item)"
        >
          <v-tooltip top>
            <template #activator="{ on }">
              <v-icon
                v-if="item.isActive"
                small
                v-on="on"
              >
                lock_open
              </v-icon>
              <v-icon
                v-else
                small
                v-on="on"
              >
                lock
              </v-icon>
            </template>
            <span v-if="item.isActive">Revoke access</span>
            <span v-else>Grant access</span>
          </v-tooltip>
        </v-btn>
      </template>
      <template #item.role="{ item }">
        <role-select :tutor="item" />
      </template>
    </v-data-table>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { changeActiveForUser, setGroups, fetchUserGroups, fetchUser } from '@/api'
import { actions } from '@/store/actions'
import { Authentication } from '@/store/modules/authentication'
import { TutorOverview } from '@/store/modules/tutor-overview'
import { Group, Tutor, UserAccount } from '@/models'
import { Assignments } from '@/store/modules/assignments'
import RoleSelect from './RoleSelect.vue'
import { ConfigModule } from '@/store/modules/config'

@Component({ components: { RoleSelect } })
export default class TutorList extends Vue {
  headers = [
    {
      text: 'Name',
      align: 'left',
      value: 'username'
    },
    {
      text: '# created',
      align: 'right',
      value: 'feedbackCreated'
    },
    {
      text: '# validated',
      align: 'right',
      value: 'feedbackValidated'
    },
    {
      text: '# locked submissions',
      align: 'right',
      value: 'reservedSubmissions'
    },
    {
      text: 'Exercise Groups',
      align: 'right',
      value: 'exerciseGroups'
    },
    {
      text: 'Has Access',
      align: 'right',
      value: 'isActive'
    },
    {
      text: 'Role',
      value: 'role'
    }
  ]

  get tutors () {
    var tlist =  TutorOverview.state.tutors.map(tutor => {
      var groups: Group[] = []
      this.userAccountGroups(tutor).then(function(value) {
        groups = value // Success!
      }, (reason) => {
        this.$notify({
          title: 'Error',
          text: `Unable to fetch tutors: ${reason}`,
          type: 'error'
      })
        return []
      })
      const reservedSubmissions = TutorOverview.state.activeAssignments[tutor.pk]
      return {
        ...tutor,
        reservedSubmissions: reservedSubmissions ? reservedSubmissions.length : 0,
      }
    })
    return tlist
  }

  get groups () {
    return Assignments.state.groups.slice()
        .filter(group => {
            return group.exam === null || group.exam.pk === ConfigModule.state.config.examId
          })
        .sort((a, b) => {
      const matches_a = a.name.match(/(\d+)/)
      const number_a = Number(matches_a === null ? 0 : matches_a[1])

      const matches_b = b.name.match(/(\d+)/)
      const number_b = Number(matches_b === null ? 0 : matches_b[1])

      return (number_a<number_b?-1:(number_a>number_b?1:0))
    })
  }


  async userAccountGroups(tutor: Tutor) {
    const groups = await (await fetchUser(tutor.pk)).exerciseGroups
    return groups
  }

  changeActiveStatus (tutor: Tutor) {
    changeActiveForUser(tutor.pk, !tutor.isActive).then(() => {
      TutorOverview.getTutors()
    }).catch(() => {
      this.$notify({
        title: 'Error',
        text: `Unable to change active status of ${tutor.username}`,
        type: 'error'
      })
    })
  }

  setExerciseGroups (groups: Group[], tutor: Tutor){
    console.log(groups)
    setGroups(tutor.pk, groups).then(() => {
      TutorOverview.getTutors()
    }).catch(() => {
      this.$notify({
        title: 'Error',
        text: `Unable to change exercise-groups of ${tutor.username}`,
        type: 'error'
      })
    })
  }

  deleteAssignmentsOfTutor (tutor: Tutor) {
    TutorOverview.deleteActiveAssignmentsOfTutor(tutor)
  }

  refresh () {
    TutorOverview.getTutors()
    TutorOverview.getActiveAssignments()
  }

  canRevokeAccess (username: string) {
    return Authentication.state.user.username !== username
  }
}
</script>

<style scoped>

</style>
